diff -uNr mythtv-0.21/libs/libavcodec/i386/h264_i386.h mythtv/libs/libavcodec/i386/h264_i386.h
--- mythtv-0.21/libs/libavcodec/i386/h264_i386.h	1970-01-01 01:00:00.000000000 +0100
+++ mythtv/libs/libavcodec/i386/h264_i386.h	2008-09-22 22:58:47.000000000 +0200
@@ -0,0 +1,144 @@
+/*
+ * H.26L/H.264/AVC/JVT/14496-10/... encoder/decoder
+ * Copyright (c) 2003 Michael Niedermayer <michaelni@gmx.at>
+ *
+ * This file is part of FFmpeg.
+ *
+ * FFmpeg is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU Lesser General Public
+ * License as published by the Free Software Foundation; either
+ * version 2.1 of the License, or (at your option) any later version.
+ *
+ * FFmpeg is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * Lesser General Public License for more details.
+ *
+ * You should have received a copy of the GNU Lesser General Public
+ * License along with FFmpeg; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+/**
+ * @file h264_i386.h
+ * H.264 / AVC / MPEG4 part10 codec.
+ * non-MMX i386-specific optimizations for H.264
+ * @author Michael Niedermayer <michaelni@gmx.at>
+ */
+
+#ifndef FFMPEG_H264_I386_H
+#define FFMPEG_H264_I386_H
+
+
+#include "cabac.h"
+
+//FIXME use some macros to avoid duplicatin get_cabac (cannot be done yet as that would make optimization work hard)
+#if defined(ARCH_X86) && defined(HAVE_7REGS) && defined(HAVE_EBX_AVAILABLE) && !defined(BROKEN_RELOCATIONS)
+static int decode_significance_x86(CABACContext *c, int max_coeff, uint8_t *significant_coeff_ctx_base, int *index){
+    void *end= significant_coeff_ctx_base + max_coeff - 1;
+    int minusstart= -(int)significant_coeff_ctx_base;
+    int minusindex= 4-(int)index;
+    int coeff_count;
+    asm volatile(
+        "movl "RANGE    "(%3), %%esi            \n\t"
+        "movl "LOW      "(%3), %%ebx            \n\t"
+
+        "2:                                     \n\t"
+
+        BRANCHLESS_GET_CABAC("%%edx", "%3", "(%1)", "%%ebx", "%%bx", "%%esi", "%%eax", "%%al")
+
+        "test $1, %%edx                         \n\t"
+        " jz 3f                                 \n\t"
+
+        BRANCHLESS_GET_CABAC("%%edx", "%3", "61(%1)", "%%ebx", "%%bx", "%%esi", "%%eax", "%%al")
+
+        "mov  %2, %%"REG_a"                     \n\t"
+        "movl %4, %%ecx                         \n\t"
+        "add  %1, %%"REG_c"                     \n\t"
+        "movl %%ecx, (%%"REG_a")                \n\t"
+
+        "test $1, %%edx                         \n\t"
+        " jnz 4f                                \n\t"
+
+        "add  $4, %%"REG_a"                     \n\t"
+        "mov  %%"REG_a", %2                     \n\t"
+
+        "3:                                     \n\t"
+        "add  $1, %1                            \n\t"
+        "cmp  %5, %1                            \n\t"
+        " jb 2b                                 \n\t"
+        "mov  %2, %%"REG_a"                     \n\t"
+        "movl %4, %%ecx                         \n\t"
+        "add  %1, %%"REG_c"                     \n\t"
+        "movl %%ecx, (%%"REG_a")                \n\t"
+        "4:                                     \n\t"
+        "add  %6, %%eax                         \n\t"
+        "shr $2, %%eax                          \n\t"
+
+        "movl %%esi, "RANGE    "(%3)            \n\t"
+        "movl %%ebx, "LOW      "(%3)            \n\t"
+        :"=&a"(coeff_count), "+r"(significant_coeff_ctx_base), "+m"(index)
+        :"r"(c), "m"(minusstart), "m"(end), "m"(minusindex)
+        : "%"REG_c, "%ebx", "%edx", "%esi", "memory"
+    );
+    return coeff_count;
+}
+
+static int decode_significance_8x8_x86(CABACContext *c, uint8_t *significant_coeff_ctx_base, int *index, const uint8_t *sig_off){
+    int minusindex= 4-(int)index;
+    int coeff_count;
+    long last=0;
+    asm volatile(
+        "movl "RANGE    "(%3), %%esi            \n\t"
+        "movl "LOW      "(%3), %%ebx            \n\t"
+
+        "mov %1, %%"REG_D"                      \n\t"
+        "2:                                     \n\t"
+
+        "mov %6, %%"REG_a"                      \n\t"
+        "movzbl (%%"REG_a", %%"REG_D"), %%edi   \n\t"
+        "add %5, %%"REG_D"                      \n\t"
+
+        BRANCHLESS_GET_CABAC("%%edx", "%3", "(%%"REG_D")", "%%ebx", "%%bx", "%%esi", "%%eax", "%%al")
+
+        "mov %1, %%edi                          \n\t"
+        "test $1, %%edx                         \n\t"
+        " jz 3f                                 \n\t"
+
+        "movzbl "MANGLE(last_coeff_flag_offset_8x8)"(%%edi), %%edi\n\t"
+        "add %5, %%"REG_D"                      \n\t"
+
+        BRANCHLESS_GET_CABAC("%%edx", "%3", "15(%%"REG_D")", "%%ebx", "%%bx", "%%esi", "%%eax", "%%al")
+
+        "mov %2, %%"REG_a"                      \n\t"
+        "mov %1, %%edi                          \n\t"
+        "movl %%edi, (%%"REG_a")                \n\t"
+
+        "test $1, %%edx                         \n\t"
+        " jnz 4f                                \n\t"
+
+        "add $4, %%"REG_a"                      \n\t"
+        "mov %%"REG_a", %2                      \n\t"
+
+        "3:                                     \n\t"
+        "addl $1, %%edi                         \n\t"
+        "mov %%edi, %1                          \n\t"
+        "cmpl $63, %%edi                        \n\t"
+        " jb 2b                                 \n\t"
+        "mov %2, %%"REG_a"                      \n\t"
+        "movl %%edi, (%%"REG_a")                \n\t"
+        "4:                                     \n\t"
+        "addl %4, %%eax                         \n\t"
+        "shr $2, %%eax                          \n\t"
+
+        "movl %%esi, "RANGE    "(%3)            \n\t"
+        "movl %%ebx, "LOW      "(%3)            \n\t"
+        :"=&a"(coeff_count),"+m"(last), "+m"(index)
+        :"r"(c), "m"(minusindex), "m"(significant_coeff_ctx_base), "m"(sig_off)
+        : "%"REG_c, "%ebx", "%edx", "%esi", "%"REG_D, "memory"
+    );
+    return coeff_count;
+}
+#endif /* defined(ARCH_X86) && && defined(HAVE_7REGS) && defined(HAVE_EBX_AVAILABLE) && !defined(BROKEN_RELOCATIONS) */
+
+#endif /* FFMPEG_H264_I386_H */
diff -uNr mythtv-0.21/libs/libavcodec/i386/motion_est_mmx.c mythtv/libs/libavcodec/i386/motion_est_mmx.c
--- mythtv-0.21/libs/libavcodec/i386/motion_est_mmx.c	2007-11-05 22:12:23.000000000 +0100
+++ mythtv/libs/libavcodec/i386/motion_est_mmx.c	2008-09-22 22:58:47.000000000 +0200
@@ -24,13 +24,13 @@
 #include "dsputil.h"
 #include "x86_cpu.h"
 
-static const __attribute__ ((aligned(8))) uint64_t round_tab[3]={
+DECLARE_ASM_CONST(8, uint64_t, round_tab[3])={
 0x0000000000000000ULL,
 0x0001000100010001ULL,
 0x0002000200020002ULL,
 };
 
-static attribute_used __attribute__ ((aligned(8))) uint64_t bone= 0x0101010101010101LL;
+DECLARE_ASM_CONST(8, uint64_t, bone)= 0x0101010101010101LL;
 
 static inline void sad8_1_mmx(uint8_t *blk1, uint8_t *blk2, int stride, int h)
 {
diff -uNr mythtv-0.21/libs/libavcodec/i386/simple_idct_mmx.c mythtv/libs/libavcodec/i386/simple_idct_mmx.c
--- mythtv-0.21/libs/libavcodec/i386/simple_idct_mmx.c	2007-11-05 22:12:23.000000000 +0100
+++ mythtv/libs/libavcodec/i386/simple_idct_mmx.c	2008-09-22 22:58:47.000000000 +0200
@@ -48,8 +48,8 @@
 #define ROW_SHIFT 11
 #define COL_SHIFT 20 // 6
 
-static const uint64_t attribute_used __attribute__((aligned(8))) wm1010= 0xFFFF0000FFFF0000ULL;
-static const uint64_t attribute_used __attribute__((aligned(8))) d40000= 0x0000000000040000ULL;
+DECLARE_ASM_CONST(8, uint64_t, wm1010)= 0xFFFF0000FFFF0000ULL;
+DECLARE_ASM_CONST(8, uint64_t, d40000)= 0x0000000000040000ULL;
 
 static const int16_t __attribute__((aligned(8))) coeffs[]= {
         1<<(ROW_SHIFT-1), 0, 1<<(ROW_SHIFT-1), 0,
diff -uNr mythtv-0.21/libs/libavcodec/libavcodec.pro mythtv/libs/libavcodec/libavcodec.pro
--- mythtv-0.21/libs/libavcodec/libavcodec.pro	2008-02-06 04:02:47.000000000 +0100
+++ mythtv/libs/libavcodec/libavcodec.pro	2008-11-05 06:18:59.000000000 +0100
@@ -27,8 +27,6 @@
 	QMAKE_CFLAGS_SHLIB =
 }
 
-mingw:target.path = $${PREFIX}/bin
-
 !profile:QMAKE_CFLAGS_DEBUG += -O
 
 QMAKE_CLEAN += $(TARGET) $(TARGETA) $(TARGETD) $(TARGET0) $(TARGET1) $(TARGET2)
@@ -410,7 +408,7 @@
 }
 
 contains( HAVE_ARMV5TE, yes ) {
-    SOURCES += armv4l/simple_idct_armv5te.S armv4l/mpegvideo_armv5te.S
+    SOURCES += armv4l/simple_idct_armv5te.S armv4l/mpegvideo_armv5te.c
 }
 
 contains( HAVE_ARMV6, yes )      { SOURCES += armv4l/simple_idct_armv6.S }
@@ -467,3 +465,4 @@
     SOURCES += bfin/vp3_idct_bfin.S
 }
 
+include ( ../libs-targetfix.pro )
diff -uNr mythtv-0.21/libs/libavcodec/mpegvideo.c mythtv/libs/libavcodec/mpegvideo.c
--- mythtv-0.21/libs/libavcodec/mpegvideo.c	2007-11-05 22:12:23.000000000 +0100
+++ mythtv/libs/libavcodec/mpegvideo.c	2008-09-22 22:58:47.000000000 +0200
@@ -591,9 +591,7 @@
     s->context_initialized = 1;
 
     s->thread_context[0]= s;
-    /* h264 does thread context setup itself, but it needs context[0]
-     * to be fully initialized for the error resilience code */
-    threads = s->codec_id == CODEC_ID_H264 ? 1 : s->avctx->thread_count;
+    threads = s->avctx->thread_count;
 
     for(i=1; i<threads; i++){
         s->thread_context[i]= av_malloc(sizeof(MpegEncContext));
diff -uNr mythtv-0.21/libs/libavcodec/mpegvideo.h mythtv/libs/libavcodec/mpegvideo.h
--- mythtv-0.21/libs/libavcodec/mpegvideo.h	2007-11-05 22:12:23.000000000 +0100
+++ mythtv/libs/libavcodec/mpegvideo.h	2008-09-23 00:19:20.000000000 +0200
@@ -142,8 +142,9 @@
     int pic_id;                 /**< h264 pic_num (short -> no wrap version of pic_num,
                                      pic_num & max_pic_num; long -> long_pic_num) */
     int long_ref;               ///< 1->long term reference 0->short term reference
-    int ref_poc[2][16];         ///< h264 POCs of the frames used as reference
-    int ref_count[2];           ///< number of entries in ref_poc
+    int ref_poc[2][2][16];      ///< h264 POCs of the frames used as reference (FIXME need per slice)
+    int ref_count[2][2];        ///< number of entries in ref_poc              (FIXME need per slice)
+    int mbaff;                  ///< h264 1 -> MBAFF frame 0-> not MBAFF
 
     int mb_var_sum;             ///< sum of MB variance for current frame
     int mc_mb_var_sum;          ///< motion compensated MB variance for current frame
diff -uNr mythtv-0.21/libs/libavcodec/rectangle.h mythtv/libs/libavcodec/rectangle.h
--- mythtv-0.21/libs/libavcodec/rectangle.h	1970-01-01 01:00:00.000000000 +0100
+++ mythtv/libs/libavcodec/rectangle.h	2008-09-22 22:58:47.000000000 +0200
@@ -0,0 +1,121 @@
+/*
+ * rectangle filling function
+ * Copyright (c) 2003 Michael Niedermayer <michaelni@gmx.at>
+ *
+ * This file is part of FFmpeg.
+ *
+ * FFmpeg is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU Lesser General Public
+ * License as published by the Free Software Foundation; either
+ * version 2.1 of the License, or (at your option) any later version.
+ *
+ * FFmpeg is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * Lesser General Public License for more details.
+ *
+ * You should have received a copy of the GNU Lesser General Public
+ * License along with FFmpeg; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+/**
+ * @file rectangle.h
+ * useful rectangle filling function
+ * @author Michael Niedermayer <michaelni@gmx.at>
+ */
+
+#ifndef FFMPEG_RECTANGLE_H
+#define FFMPEG_RECTANGLE_H
+
+#include "common.h"
+
+/**
+ * fill a rectangle.
+ * @param h height of the rectangle, should be a constant
+ * @param w width of the rectangle, should be a constant
+ * @param size the size of val (1 or 4), should be a constant
+ */
+static av_always_inline void fill_rectangle(void *vp, int w, int h, int stride, uint32_t val, int size){
+    uint8_t *p= (uint8_t*)vp;
+    assert(size==1 || size==4);
+    assert(w<=4);
+
+    w      *= size;
+    stride *= size;
+
+    assert((((long)vp)&(FFMIN(w, STRIDE_ALIGN)-1)) == 0);
+    assert((stride&(w-1))==0);
+    if(w==2){
+        const uint16_t v= size==4 ? val : val*0x0101;
+        *(uint16_t*)(p + 0*stride)= v;
+        if(h==1) return;
+        *(uint16_t*)(p + 1*stride)= v;
+        if(h==2) return;
+        *(uint16_t*)(p + 2*stride)= v;
+        *(uint16_t*)(p + 3*stride)= v;
+    }else if(w==4){
+        const uint32_t v= size==4 ? val : val*0x01010101;
+        *(uint32_t*)(p + 0*stride)= v;
+        if(h==1) return;
+        *(uint32_t*)(p + 1*stride)= v;
+        if(h==2) return;
+        *(uint32_t*)(p + 2*stride)= v;
+        *(uint32_t*)(p + 3*stride)= v;
+    }else if(w==8){
+    //gcc can't optimize 64bit math on x86_32
+#if defined(ARCH_X86_64) || (defined(MP_WORDSIZE) && MP_WORDSIZE >= 64)
+        const uint64_t v= val*0x0100000001ULL;
+        *(uint64_t*)(p + 0*stride)= v;
+        if(h==1) return;
+        *(uint64_t*)(p + 1*stride)= v;
+        if(h==2) return;
+        *(uint64_t*)(p + 2*stride)= v;
+        *(uint64_t*)(p + 3*stride)= v;
+    }else if(w==16){
+        const uint64_t v= val*0x0100000001ULL;
+        *(uint64_t*)(p + 0+0*stride)= v;
+        *(uint64_t*)(p + 8+0*stride)= v;
+        *(uint64_t*)(p + 0+1*stride)= v;
+        *(uint64_t*)(p + 8+1*stride)= v;
+        if(h==2) return;
+        *(uint64_t*)(p + 0+2*stride)= v;
+        *(uint64_t*)(p + 8+2*stride)= v;
+        *(uint64_t*)(p + 0+3*stride)= v;
+        *(uint64_t*)(p + 8+3*stride)= v;
+#else
+        *(uint32_t*)(p + 0+0*stride)= val;
+        *(uint32_t*)(p + 4+0*stride)= val;
+        if(h==1) return;
+        *(uint32_t*)(p + 0+1*stride)= val;
+        *(uint32_t*)(p + 4+1*stride)= val;
+        if(h==2) return;
+        *(uint32_t*)(p + 0+2*stride)= val;
+        *(uint32_t*)(p + 4+2*stride)= val;
+        *(uint32_t*)(p + 0+3*stride)= val;
+        *(uint32_t*)(p + 4+3*stride)= val;
+    }else if(w==16){
+        *(uint32_t*)(p + 0+0*stride)= val;
+        *(uint32_t*)(p + 4+0*stride)= val;
+        *(uint32_t*)(p + 8+0*stride)= val;
+        *(uint32_t*)(p +12+0*stride)= val;
+        *(uint32_t*)(p + 0+1*stride)= val;
+        *(uint32_t*)(p + 4+1*stride)= val;
+        *(uint32_t*)(p + 8+1*stride)= val;
+        *(uint32_t*)(p +12+1*stride)= val;
+        if(h==2) return;
+        *(uint32_t*)(p + 0+2*stride)= val;
+        *(uint32_t*)(p + 4+2*stride)= val;
+        *(uint32_t*)(p + 8+2*stride)= val;
+        *(uint32_t*)(p +12+2*stride)= val;
+        *(uint32_t*)(p + 0+3*stride)= val;
+        *(uint32_t*)(p + 4+3*stride)= val;
+        *(uint32_t*)(p + 8+3*stride)= val;
+        *(uint32_t*)(p +12+3*stride)= val;
+#endif
+    }else
+        assert(0);
+    assert(h==4);
+}
+
+#endif /* FFMPEG_RECTANGLE_H */
diff -uNr mythtv-0.21/libs/libavformat/libavformat.pro mythtv/libs/libavformat/libavformat.pro
--- mythtv-0.21/libs/libavformat/libavformat.pro	2008-02-06 04:02:47.000000000 +0100
+++ mythtv/libs/libavformat/libavformat.pro	2008-06-04 06:05:51.000000000 +0200
@@ -13,8 +13,6 @@
 
 LIBS += $$LOCAL_LIBDIR_X11 $$EXTRALIBS
 
-mingw:  target.path = $${PREFIX}/bin
-
 QMAKE_CLEAN += $(TARGET) $(TARGETA) $(TARGETD) $(TARGET0) $(TARGET1) $(TARGET2)
 
 # Input
@@ -198,3 +196,5 @@
 }
 
 mingw:SOURCES -= audio.c
+
+include ( ../libs-targetfix.pro )
diff -uNr mythtv-0.21/libs/libavformat/utils.c mythtv/libs/libavformat/utils.c
--- mythtv-0.21/libs/libavformat/utils.c	2008-02-21 23:29:22.000000000 +0100
+++ mythtv/libs/libavformat/utils.c	2008-03-26 16:51:18.000000000 +0100
@@ -580,6 +580,10 @@
 
     *pnum = 0;
     *pden = 0;
+
+    if (!st || !st->codec)
+        return;
+    
     switch(st->codec->codec_type) {
     case CODEC_TYPE_VIDEO:
         if(st->time_base.num*1000LL > st->time_base.den){
@@ -792,7 +796,7 @@
     for(;;) {
         /* select current input stream component */
         st = s->cur_st;
-        if (st) {
+        if (st && st->codec) {
             if (!st->need_parsing || !st->parser) {
                 /* no parsing needed: we just output the packet as is */
                 /* raw data support */
@@ -867,7 +871,7 @@
                 s->cur_pkt.pos = startpos;
 
             st = s->streams[s->cur_pkt.stream_index];
-            if(st->codec->debug & FF_DEBUG_PTS)
+            if(st && st->codec && st->codec->debug & FF_DEBUG_PTS)
                 av_log(s, AV_LOG_DEBUG, "av_read_packet stream=%d, pts=%"PRId64", dts=%"PRId64", size=%d\n",
                     s->cur_pkt.stream_index,
                     s->cur_pkt.pts,
@@ -877,7 +881,7 @@
             s->cur_st = st;
             s->cur_ptr = s->cur_pkt.data;
             s->cur_len = s->cur_pkt.size;
-            if (st->need_parsing && !st->parser) {
+            if (st && st->codec && st->need_parsing && !st->parser) {
                 st->parser = av_parser_init(st->codec->codec_id);
                 if (!st->parser) {
                     /* no parser available : just output the raw packets */
@@ -892,7 +896,7 @@
             }
         }
     }
-    if(st->codec->debug & FF_DEBUG_PTS)
+    if(st->codec && st->codec->debug & FF_DEBUG_PTS)
         av_log(s, AV_LOG_DEBUG, "av_read_frame_internal stream=%d, pts=%"PRId64", dts=%"PRId64", size=%d\n",
             pkt->stream_index,
             pkt->pts,
diff -uNr mythtv-0.21/libs/libavutil/common.h mythtv/libs/libavutil/common.h
--- mythtv-0.21/libs/libavutil/common.h	2007-11-05 22:12:23.000000000 +0100
+++ mythtv/libs/libavutil/common.h	2008-09-22 22:58:47.000000000 +0200
@@ -89,7 +89,9 @@
 #define FFSIGN(a) ((a) > 0 ? 1 : -1)
 
 #define FFMAX(a,b) ((a) > (b) ? (a) : (b))
+#define FFMAX3(a,b,c) FFMAX(FFMAX(a,b),c)
 #define FFMIN(a,b) ((a) > (b) ? (b) : (a))
+#define FFMIN3(a,b,c) FFMIN(FFMIN(a,b),c)
 
 #define FFSWAP(type,a,b) do{type SWAP_tmp= b; b= a; a= SWAP_tmp;}while(0)
 
diff -uNr mythtv-0.21/libs/libavutil/libavutil.pro mythtv/libs/libavutil/libavutil.pro
--- mythtv-0.21/libs/libavutil/libavutil.pro	2007-12-11 15:56:01.000000000 +0100
+++ mythtv/libs/libavutil/libavutil.pro	2008-06-04 06:05:51.000000000 +0200
@@ -53,4 +53,4 @@
     QMAKE_LFLAGS_SHLIB += -seg1addr 0xC2000000
 }
 
-mingw:  target.path = $${PREFIX}/bin
+include ( ../libs-targetfix.pro )
diff -uNr mythtv-0.21/libs/libavutil/mem.h mythtv/libs/libavutil/mem.h
--- mythtv-0.21/libs/libavutil/mem.h	2007-11-05 22:12:23.000000000 +0100
+++ mythtv/libs/libavutil/mem.h	2008-09-22 22:58:47.000000000 +0200
@@ -28,8 +28,10 @@
 
 #ifdef __GNUC__
   #define DECLARE_ALIGNED(n,t,v)       t v __attribute__ ((aligned (n)))
+  #define DECLARE_ASM_CONST(n,t,v)     static const t v attribute_used __attribute__ ((aligned (n)))
 #else
   #define DECLARE_ALIGNED(n,t,v)      __declspec(align(n)) t v
+  #define DECLARE_ASM_CONST(n,t,v)    __declspec(align(n)) static const t v
 #endif
 
 /**
diff -uNr mythtv-0.21/libs/libmyth/audiopulseutil.cpp mythtv/libs/libmyth/audiopulseutil.cpp
--- mythtv-0.21/libs/libmyth/audiopulseutil.cpp	1970-01-01 01:00:00.000000000 +0100
+++ mythtv/libs/libmyth/audiopulseutil.cpp	2009-04-20 05:33:44.000000000 +0200
@@ -0,0 +1,383 @@
+/***
+ *   This file was part of PulseAudio, the license has been upgraded to GPL v2
+ *   or later as per the LGPL grant this was originally distributed under.
+ *
+ *   Copyright 2004-2006 Lennart Poettering
+ *
+ *   MythTV is free software; you can redistribute it and/or modify
+ *   it under the terms of the GNU General Public License as published by
+ *   the Free Software Foundation; either version 2 of the License, or
+ *   (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ */
+
+#include "audiopulseutil.h"
+#include "util.h" // for IsPulseAudioRunning()
+#include "exitcodes.h"
+#include "mythcontext.h"
+
+#ifdef USING_PULSE
+
+#include <sys/types.h>
+#include <sys/wait.h>
+
+#include <signal.h>
+#include <string.h>
+#include <errno.h>
+#include <unistd.h>
+#include <assert.h>
+#include <stdio.h>
+#include <stdlib.h>
+#include <limits.h>
+#include <getopt.h>
+#include <locale.h>
+
+#ifdef __linux__
+#include <sys/prctl.h>
+#endif
+
+#include <pulse/pulseaudio.h>
+
+#include <qthread.h>
+#include <qmutex.h>
+#include <qwaitcondition.h>
+
+#define BUFSIZE 1024
+
+#define LOC      QString("AudioPulseUtil: ")
+#define LOC_WARN QString("AudioPulseUtil, Warning: ")
+#define LOC_ERR  QString("AudioPulseUtil, Error: ")
+
+enum pa_values {
+    kPA_undefined                   = -1,
+    kPA_suspended                   = +0,
+    kPA_not_suspended_remote_server = +1,
+    kPA_not_suspended_error         = +2,
+    kPA_not_suspended_success       = +3,
+    kPA_unsuspended_error           = +4,
+    kPA_unsuspended_success         = +5,
+};
+
+static pa_context      *pau_context = NULL;
+static pa_mainloop_api *pau_mainloop_api = NULL;
+static QMutex           pau_lock;
+static QWaitCondition   pau_wait;
+static int              pau_value = kPA_undefined;
+
+static void pau_set_value(int new_value)
+{
+    QMutexLocker ml(&pau_lock);
+    pau_value = new_value;
+    pau_wait.wakeAll();
+}
+
+static void pau_quit(int ret)
+{
+    if (pau_mainloop_api)
+        pau_mainloop_api->quit(pau_mainloop_api, ret);
+}
+
+static void pau_context_drain_complete(pa_context *c, void *userdata)
+{
+    if (c)
+        pa_context_disconnect(c);
+}
+
+static void pau_drain(void)
+{
+    if (!pau_context)
+        return;
+
+    pa_operation *operation = pa_context_drain(pau_context, pau_context_drain_complete, NULL);
+    if (!operation)
+        pa_context_disconnect(pau_context);
+    else
+        pa_operation_unref(operation);
+}
+
+static void pau_suspend_complete(pa_context *c, int success, void *userdata)
+{
+    if (!success)
+    {
+        if (!c)
+            return;
+
+        VERBOSE(VB_IMPORTANT, LOC_ERR + QString("Failure to suspend: %1")
+                .arg(pa_strerror(pa_context_errno(c))));
+
+        pau_set_value(kPA_not_suspended_error);
+
+        return;
+    }
+
+    {
+        QMutexLocker ml(&pau_lock);
+        if (kPA_suspended == pau_value)
+            return;
+    }
+
+    VERBOSE(VB_GENERAL, LOC + "Suspend Success");
+
+    pau_set_value(kPA_suspended);
+}
+
+static void pau_resume_complete(pa_context *c, int success, void *userdata)
+{
+    static int n = 0;
+
+    n++;
+
+    if (!success)
+    {
+        if (!c)
+            return;
+
+        VERBOSE(VB_IMPORTANT, LOC_ERR + QString("Failure to resume: %1")
+                .arg(pa_strerror(pa_context_errno(c))));
+
+        pau_set_value(kPA_unsuspended_error);
+
+        return;
+    }
+
+    if (n >= 2)
+        pau_drain(); /* drain and quit */
+
+    {
+        QMutexLocker ml(&pau_lock);
+        if (kPA_unsuspended_success == pau_value)
+            return;
+    }
+
+    VERBOSE(VB_GENERAL, LOC + "Resume Success");
+
+    pau_set_value(kPA_unsuspended_success);
+}
+
+static void pau_context_state_callback(pa_context *c, void *userdata)
+{
+    if (!c)
+        return;
+
+    switch (pa_context_get_state(c))
+    {
+        case PA_CONTEXT_CONNECTING:
+        case PA_CONTEXT_AUTHORIZING:
+        case PA_CONTEXT_SETTING_NAME:
+            break;
+
+        case PA_CONTEXT_READY:
+            if (pa_context_is_local(c))
+            {
+                pa_operation *operation_sink =
+                    pa_context_suspend_sink_by_index(
+                        c, PA_INVALID_INDEX, 1, pau_suspend_complete, NULL);
+                pa_operation_unref(operation_sink);
+
+                pa_operation *operation_source =
+                    pa_context_suspend_source_by_index(
+                        c, PA_INVALID_INDEX, 1, pau_suspend_complete, NULL);
+                pa_operation_unref(operation_source);
+            }
+            else
+            {
+                VERBOSE(VB_IMPORTANT, LOC_ERR +
+                        "Sound server is not local, can not suspend.");
+
+                pau_set_value(kPA_not_suspended_remote_server);
+            }
+
+            break;
+
+        case PA_CONTEXT_TERMINATED:
+            pau_quit(0);
+            break;
+
+        case PA_CONTEXT_FAILED:
+        default:
+            VERBOSE(VB_IMPORTANT, LOC_WARN +
+                    "Can not connect to sound server, can not suspend." +
+                    QString("\n\t\t\t%1")
+                    .arg(pa_strerror(pa_context_errno(c))));
+
+            pau_set_value(kPA_not_suspended_error);
+
+            if (pau_context)
+            {
+                pa_context_unref(pau_context);
+                pau_context = NULL;
+            }
+
+            break;
+    }
+}
+
+void pau_pulseaudio_suspend_internal(void)
+{
+    pa_mainloop* m = NULL;
+    int ret = 1;
+    char *server = NULL;
+    const char *bn = "mythtv";
+
+    if (!(m = pa_mainloop_new()))
+    {
+        VERBOSE(VB_IMPORTANT, LOC_ERR + "pa_mainloop_new() failed.");
+        goto quit;
+    }
+
+    pau_mainloop_api = pa_mainloop_get_api(m);
+    if (!pau_mainloop_api)
+        goto quit;
+
+    if (pa_signal_init(pau_mainloop_api) != 0)
+        goto quit;
+
+    if (!(pau_context = pa_context_new(pau_mainloop_api, bn)))
+    {
+        VERBOSE(VB_IMPORTANT, LOC_ERR + "pa_context_new() failed.");
+        goto quit;
+    }
+
+    pa_context_set_state_callback(pau_context, pau_context_state_callback, NULL);
+    pa_context_connect(pau_context, server, PA_CONTEXT_NOAUTOSPAWN, NULL);
+
+    if (pa_mainloop_run(m, &ret) < 0)
+    {
+        VERBOSE(VB_IMPORTANT, LOC_ERR + "pa_mainloop_run() failed.\n");
+        goto quit;
+    }
+
+quit:
+    if (pau_context)
+        pa_context_unref(pau_context);
+
+    if (m) {
+        pa_signal_done();
+        pa_mainloop_free(m);
+    }
+
+    pa_xfree(server);
+}
+
+class PAThread : public QThread
+{
+  public:
+    void run(void)
+    {
+        pau_pulseaudio_suspend_internal();
+    }
+};
+
+/// \returns true if successful
+bool pulseaudio_suspend(void)
+{
+    QThread *t = new PAThread();
+    t->start();
+
+    QMutexLocker ml(&pau_lock);
+    while (kPA_undefined == pau_value)
+        pau_wait.wait(&pau_lock);
+
+    return kPA_suspended == pau_value;
+}
+
+/// \returns true if successful
+bool pulseaudio_unsuspend(void)
+{
+    if (!pau_context)
+    {
+        pau_quit(0);
+        return false;
+    }
+
+    if (pa_context_is_local(pau_context))
+    {
+        pa_operation *operation_sink =
+            pa_context_suspend_sink_by_index(
+                pau_context, PA_INVALID_INDEX, 0, pau_resume_complete, NULL);
+        pa_operation_unref(operation_sink);
+
+        pa_operation *operation_source =
+            pa_context_suspend_source_by_index(
+                pau_context, PA_INVALID_INDEX, 0, pau_resume_complete, NULL);
+        pa_operation_unref(operation_source);
+
+        QMutexLocker ml(&pau_lock);
+        while ((kPA_unsuspended_error   != pau_value) &&
+               (kPA_unsuspended_success != pau_value))
+        {
+            pau_wait.wait(&pau_lock);
+        }
+
+        return kPA_unsuspended_success == pau_value;
+    }
+    else
+    {
+        pau_drain();
+    }
+
+    return false;
+}
+
+#endif // USING_PULSE
+
+int pulseaudio_handle_startup(void)
+{
+#ifdef USING_PULSE
+    if (getenv("EXPERIMENTALLY_ALLOW_PULSE_AUDIO"))
+    {
+        VERBOSE(VB_IMPORTANT, "WARNING: ");
+        VERBOSE(VB_IMPORTANT, "WARNING: ***Pulse Audio is running!!!!***");
+        VERBOSE(VB_IMPORTANT, "WARNING: ");
+        VERBOSE(VB_IMPORTANT, "WARNING: You have told MythTV to ignore it.");
+        VERBOSE(VB_IMPORTANT, "WARNING: ");
+    }
+    else if (IsPulseAudioRunning() && !pulseaudio_suspend())
+    {
+        VERBOSE(VB_IMPORTANT, "ERROR: ***Pulse Audio is running!!!!***");
+        VERBOSE(VB_IMPORTANT,
+                "ERROR: But MythTV was not able to suspend it. EXITING!");
+
+        return GENERIC_EXIT_NOT_OK;
+    }
+#else
+    if (IsPulseAudioRunning())
+    {
+        VERBOSE(VB_IMPORTANT, "ERROR: ***Pulse Audio is running!!!!***");
+        VERBOSE(VB_IMPORTANT, "ERROR: But MythTV has not been compiled "
+                "with Pulse Audio disabling support. EXITING!");
+        return GENERIC_EXIT_NOT_OK;
+    }
+#endif
+
+    return GENERIC_EXIT_OK;
+}
+
+int pulseaudio_handle_teardown(void)
+{
+#ifdef USING_PULSE
+    if (getenv("EXPERIMENTALLY_ALLOW_PULSE_AUDIO"))
+        return GENERIC_EXIT_OK;
+
+    {
+        QMutexLocker ml(&pau_lock);
+        if (kPA_suspended != pau_value)
+            return GENERIC_EXIT_OK;
+    }
+
+    if (!pulseaudio_unsuspend())
+    {
+        VERBOSE(VB_IMPORTANT, "ERROR: Encountered error re-enabling pulse audio");
+    }
+#endif
+
+    return GENERIC_EXIT_OK;
+}
diff -uNr mythtv-0.21/libs/libmyth/audiopulseutil.h mythtv/libs/libmyth/audiopulseutil.h
--- mythtv-0.21/libs/libmyth/audiopulseutil.h	1970-01-01 01:00:00.000000000 +0100
+++ mythtv/libs/libmyth/audiopulseutil.h	2009-04-20 05:33:44.000000000 +0200
@@ -0,0 +1,6 @@
+#include "mythexp.h"
+
+MPUBLIC bool pulseaudio_suspend(void);
+MPUBLIC bool pulseaudio_unsuspend(void);
+MPUBLIC int  pulseaudio_handle_startup(void);
+MPUBLIC int  pulseaudio_handle_teardown(void);
diff -uNr mythtv-0.21/libs/libmyth/compat.h mythtv/libs/libmyth/compat.h
--- mythtv-0.21/libs/libmyth/compat.h	2008-02-18 08:35:01.000000000 +0100
+++ mythtv/libs/libmyth/compat.h	2008-10-22 05:27:57.000000000 +0200
@@ -259,6 +259,10 @@
 #endif // USING_MINGW
 
 
+#include <sys/param.h>  // Defines BSD on FreeBSD, Mac OS X
+#include <sys/stat.h>   // S_IREAD/WRITE on MinGW, umask() on BSD
+
+
 // suseconds_t
 #include <sys/types.h>
 
@@ -271,9 +275,9 @@
     typedef int32_t suseconds_t;   // 10.3 or earlier don't have this
 #endif
 
-// Libdvdnav now uses off64_t lseek64(), which Darwin doesn't have.
+// Libdvdnav now uses off64_t lseek64(), which BSD/Darwin doesn't have.
 // Luckily, its lseek() is already 64bit compatible
-#ifdef CONFIG_DARWIN
+#ifdef BSD
     typedef off_t off64_t;
     #define lseek64(f,o,w) lseek(f,o,w)
 #endif
